(defun c:tuboarquea3 (/	     gc:aco gc:lin gc:arc sepcot long	centro
		      radio  sigue  pow	   oscad  lec	 pt	mod
		      px     x1	    x2	   y1	  y2	 ang1	ang2
		      pt1    ang    incr   diam	  a1	 a2	p
		      LH     LAH    angx   lpt	  aho	 lec	ang0
		      rint   rext   pm0	   pti0	  pm01	 pti1	pti2
		      pm1    ptex1  ptex2  ptex3
		     )
					;si no existe el tipo de linea del eje, definirlo
  (if (null (tblsearch "LTYPE" "ACAD_ISO04W100"))
    (entmake '((0 . "LTYPE")
	       (100 . "AcDbSymbolTableRecord")
	       (100 . "AcDbLinetypeTableRecord")
	       (2 . "ACAD_ISO04W100")
	       (70 . 0)
	       (3 . " ISO trazo largo, punto ____ . ____")
	       (72 . 65)
	       (73 . 4)
	       (40 . 30.0)
	       (49 . 24.0)
	       (74 . 0)
	       (49 . -3.0)
	       (74 . 0)
	       (49 . 0.0)
	       (74 . 0)
	       (49 . -3.0)
	       (74 . 0)
	      )
    )
  )

  (vl-load-com)
  (setq dibujo_activo (vla-get-activedocument (vlax-get-acad-object)))
  (if (not (tblsearch "LAYER" "Cotas"))
    (progn
      (setq *capas* (vla-get-Layers dibujo_activo))
					;obtenemos una referencia de la tabla de capas
      (setq nueva_capa (vla-add *capas* "Cotas"))
					; creamos una nueva capa.
      (vlax-put-property nueva_capa 'Color 1)
					;pone color 150 a la capa 
      (vlax-put-property nueva_capa 'Linetype "Continuous")
					;pone el tipo de linea "Continuous"
    )					;fin Progn
  )					;fin IF
					;----------------------------------------------------------------------------------
(setq puntoinicioprinc (getpoint "punto de inicio del arco:\n"))
(setq puntomedioprinc (getpoint "punto intermedio del arco:\n"))
(setq puntofinalprinc (getpoint "punto final del arco:\n"))


  (setq ref (getvar "OSMODE"))		;Para extraer el valor actual de OSMODE
  (setvar "OSMODE" 0)			;Para desactivar las referencias a objetos


  
(command "_arc" puntoinicioprinc puntomedioprinc puntofinalprinc)

(setq arcocentral (entget (entlast)))


  (setq centroprincipal (cdr (assoc 10 arcocentral)))
  (setq anginiprincipal  (cdr (assoc 50 arcocentral)))
 (setq angfinprincipal  (cdr (assoc 51 arcocentral)))
 (setq radioprincipal  (cdr (assoc 40 arcocentral)))
(setq angbarrido (- angfinprincipal anginiprincipal))
(entdel (entlast ))

	(setq angrr1 (* 1 (/ (- angfinprincipal anginiprincipal) 8)))
  	(setq angrr2 (* 2 (/ (- angfinprincipal anginiprincipal) 8)))
  	(setq angrr3 (* 3 (/ (- angfinprincipal anginiprincipal) 8)))

					;----------------------------------------------------------------------------------

  (if (= diam nil)
    (setq diam 70.0)
  )
  (setq diamant diam)

  (setq	diam (getreal
	       (strcat "\nDiametro del tubo<" (rtos diamant 2 0) ">:")
	     )
  )

  (if (= diam nil)
    (setq diam diamant)
  )


  (if (= longc nil)
    (setq longc 5500)
  )

  (setq longant longc)
  (setq
    longc (getint
	    (strcat "\nLongitud maxima por tubo<" (itoa longant) ">:")
	  )
  )

  (if (= longc nil)
    (setq longc longant)
  )



					;funciones auxiliares para crear entidades (cota long.arco, linea y arco)



  (defun gc:aco	(aini afin ext texto1 radio1 /)
    (entmake
      (list
	'(0 . "ARC_DIMENSION")
	'(100 . "AcDbEntity")
	'(8 . "Cotas")
					;'(62 . 2)
	'(100 . "AcDbDimension")
	'(280 . 0)
	(cons 10
	      (polar centro
		     (/ (+ afin aini) 2)
		     (+ radio1 (* sepcot ext))
	      )
	)
	(cons 11
	      (polar centro
		     (/ (+ afin aini) 2)
		     (+ radio1 (* sepcot ext))
	      )
	)
	'(12 0.0 0.0 0.0)
	'(70 . 37)
	(cons 1 texto1)
	'(71 . 5)
	'(72 . 1)
	(cons 3
	      (cond (estilo)
		    ((getvar "dimstyle"))
	      )
	)
	'(100 . "AcDbArcDimension")
	(cons 13 (polar centro aini radio1))
	(cons 14 (polar centro afin radio1))
	(cons 15 centro)
	'(70 . 0)
	(cons 41
	      (if aho
		ang1
		ang2
	      )
	)
	'(71 . 0)
	(cons 16 (polar centro ang0 radio1))
	(cons 17
	      (polar centro
		     (if aho
		       ang1
		       ang2
		     )
		     radio1
	      )
	)
	'(18 0.0 0.0 0.0)
	'(42 . 0.0)
	'(50 . 0.0)
      )
    )
  )

  (defun gc:acra (centro1 radio1 angulito1 texto1 /)

    (setq texto1 (strcat texto1 " <>"))

    (entmake
      (list
	'(0 . "DIMENSION")

					;'(5 . "1EC9")
					;'(102 . "{ACAD_XDICTIONARY") 

					;'(102 . "}") 
					;'(102 . "{ACAD_REACTORS")

	'(100 . "AcDbEntity")

					;'(67 . "0") 

					;'(410 . "Model") 
	'(8 . "Cotas")
					;'(62 . 1) 
	'(100 . "AcDbDimension")
	'(280 . 0)
					;'(2 . "*D249") 
	(cons 10 centro1)



	(list 11
	      (- (car centro1) (/ radio1 3))
	      (+ (cadr centro1) (/ radio1 3))
	      0.0
	)
	'(12 0.0 0.0 0.0)
	'(70 . 164)
	(CONS 1 texto1)
	'(72 . 1)
	'(71 . 5)
	'(72 . 1)
	'(41 . 1.0)
	(cons 42 radio1)
	'(73 . 0)
	'(74 . 0)
	'(75 . 0)
	'(52 . 0.0)
	'(53 . 0.0)
	'(54 . 0.0)
	'(51 . 0.0)
	'(210 0.0 0.0 1.0)
	(cons 3
	      (cond (estilo)
		    ((getvar "dimstyle"))
	      )
	)
	'(100 . "AcDbRadialDimension")
	'(13 0.0 0.0 0.0)
	'(14 0.0 0.0 0.0)
	(list 15
	      (- (car centro1) (* (sin angulito1) radio1))
	      (+ (cadr centro1) (* (cos angulito1) radio1))
	      0.0
	)
	'(16 0.0 0.0 0.0)
	'(40 . 0.0)
	'(50 . 0.0)

      )
    )
  )

  (setq contador 0)


  (defun jm:pm (p3 p4 / pm)

    (setq
      pm (list (+ (/ (- (car p4) (car p3)) 2) (car p3))
	       (+ (/ (- (cadr p4) (cadr p3)) 2) (cadr p3))
	 )
    )
  )



  (defun gc:lin	(p1 p2)
    (entmake
      (list
	'(0 . "LINE")
	'(8 . "0")
	'(62 . 256)
	'(6 . "BYLAYER")
	(cons 10 p1)
	(cons 11 p2)
      )
    )
  )
  (defun gc:arc	(rad lty col)
    (entmake
      (list
	'(0 . "ARC")
	(cons 10 centro)
	(cons 62 col)
	'(8 . "0")
	(cons 6 lty)
	(cons 40 rad)
	(cons 50 ang1)
	(cons 51 ang2)
      )
    )
  )
					;PRINCIPAL

  (setq entrada 0)

  (setq	centro centroprincipal


	radio  radioprincipal
  )

;;;  (while (= entrada 0)
;;;
;;;    (setq tipotubo (getstring
;;;		     "\n selecciona longitud(L)   angulo barrido(A):"
;;;		   )
;;;    )
;;;    (if	(or (eq tipotubo "l")
;;;	    (eq tipotubo "a")
;;;	    (eq tipotubo "A")
;;;	    (eq tipotubo "L")
;;;	)
;;;      (setq entrada 1)
;;;    )
;;;
;;;
;;;  )


;;;  (if
;;;    (or
;;;      (eq tipotubo "l")
;;;      (eq tipotubo "L")
;;;    )
;;;
;;;
;;;     (setq long (getdist "\nlongitud total del arco:"))
;;;
;;;     (progn
;;;
;;;       (while
;;;	 (< 360
;;;	    (setq anggrados (getdist "\nAngulo barrido en grados:"))
;;;	 )
;;;	  (princ "el angulo debe ser menor de 360")
;;;       )
;;;
;;;       (setq long (* (* (/ anggrados 180) pi) radio))
;;;
;;;     )
;;;
;;;
;;;
;;;  )

(setq long (* angbarrido radio))

  (setq	sepcot (* 2.5 (getvar "dimtxt") (getvar "dimscale"))
					;separacion de cotas de long de arco desde el tubo
					;Obtener valores
;;;	long   (getdist "\nlongitud total del arco:")
;;;	centro (getpoint "\nCentro:")
  )
					;comprobaci n de radio seg n longitud de arco indicada
  (while (< radio (/ long 2 pi))



;;;    (setq radio (getdist "\nRadio:" centro))

    (princ
      (strcat " - ERROR - Radio debe ser mayor o igual que "
	      (rtos (/ long 2 pi))
      )
    )
  )



					;Lectura del punto inical con vista previa
;;;  (princ "\nPunto incial:")
;;;  (setq	sigue t
;;;	pow   -1
;;;	oscad (apply
;;;		'strcat
;;;		(mapcar
;;;		  '(lambda (cad)
;;;		     (if (zerop	(logand	(getvar "osmode")
;;;					(expt 2 (setq pow (1+ pow)))
;;;				)
;;;			 )
;;;		       ""
;;;		       cad
;;;		     )
;;;		   )
;;;		  '("_END,"    "_MID,"	  "_CEN,"    "_NOD,"
;;;		    "_QUA,"    "_INT,"	  "_INS,"    "_PER,"
;;;		    "_TAN,"    "_NEA,"	  "_GCE,"    "_APP,"
;;;		    "_EXT,"    "_PAR"
;;;		   )
;;;		)
;;;	      )
;;;  )
;;;  (while (and
;;;	   sigue
;;;	   (setq lec (grread t))
;;;	 )
;;;    (cond
;;;      ((= (car lec) 5)
;;;       (redraw)
;;;       (if (null (setq pt puntoinicioprinc))
;;;	 (setq pt  (cadr lec)
;;;	       mod 0
;;;	 )
;;;	 (progn
;;;	   (setq px  (/ (getvar "viewsize") 80)
;;;		 x1  (- (car pt) px)
;;;		 x2  (+ (car pt) px)
;;;		 y1  (- (cadr pt) px)
;;;		 y2  (+ (cadr pt) px)
;;;		 mod 1
;;;	   )
;;;	   (grvecs (list 50
;;;			 (list x1 y1)
;;;			 (list x1 y2)
;;;			 (list x1 y2)
;;;			 (list x2 y2)
;;;			 (list x2 y2)
;;;			 (list x2 y1)
;;;			 (list x2 y1)
;;;			 (list x1 y1)
;;;		   )
;;;	   )
;;;	 )
;;;       )
;;;       (grdraw
;;;	 centro
;;;	 (polar centro (angle centro pt) radio)
;;;	 240
;;;	 mod
;;;       )
;;;      )
;;;      ((= (car lec) 3)
;;;       (setq ang1  (angle centro (cadr lec))
;;;	     pt1   (polar centro ang1 radio)
;;;	     sigue nil
;;;       )
;;;       (redraw)
;;;      )
;;;    )
;;;  )
					;Fin de lectura del punto inical


 (setq lec puntoinicioprinc)
  (setq ang1 angfinprincipal

;;;	 (angle centro
;;;		     ;(cadr
;;;		       lec)
;;;		    ; )
	     pt1   (polar centro ang1 radio)
	     sigue nil
       )


  ;otros valores
  (setq	ang  (/ long radio)
	incr (/ longc radio)

  )
					;Lectura del sentido del arco con vista previa
					;LH es la sucesi n de trazos del arco en sentido Horario
  (setq	a1 ang1
	a2 (+ a1 ang)
	p  (polar centro a1 radio)
  )
  (while (< a1 a2)
    (setq a1 (+ a1 0.1)
	  LH (cons
	       (list
		 p
		 (setq p (polar centro a1 radio))
	       )
	       LH
	     )
    )
  )
  (setq	LH (cons 50
		 (apply 'append (cons (list p (polar centro a2 radio)) LH))
	   )
					;LAH es la sucesi n de trazos del arco en sentido AntiHorario
	a1 ang1
	a2 (- a1 ang)
	p  (polar centro a1 radio)
  )
  (while (> a1 a2)
    (setq a1  (- a1 0.1)
	  LAH (cons
		(list
		  p
		  (setq p (polar centro a1 radio))
		)
		LAH
	      )
    )
  )
;;;  (setq	LAH   (cons 50
;;;		    (apply 'append (cons (list p (polar centro a2 radio)) LAH))
;;;	      )
;;;					;Presentar el arco seg n el usuario desplace el puntero
;;;	angx  (angle pt1 centro)
;;;	lpt   (cadr (grread t))
;;;	aho   (null (minusp (sin (- angx (angle pt1 lpt)))))
;;;	sigue t
;;;  )


  
;;;  (while (and
;;;	   sigue
;;;	   (setq lec (grread t))
;;;	 )
;;;    (cond
;;;					;si se movi  el cursor
;;;      ((= (car lec) 5)
;;;       (if (/= (setq pt (cadr lec)) lpt)
;;;	 (setq aho (null (minusp (sin (- angx (angle pt1 pt)))))
;;;	       lpt pt
;;;	 )
;;;       )
;;;       (redraw)
;;;       (grdraw centro pt1 150 0)
;;;       (grdraw pt1 (cadr lec) 240 1)
;;;       (grvecs 
;;;		 LH
;;;		 
;;;	       
;;;       )
;;;       (setvar "modemacro"
;;;	     
;;;		
;;;		 "HORARIO"
;;;	      
;;;       )
;;;      )
;;;					;si se hizo click o presion  enter
;;;      ((or
;;;	 (= (car lec) 3)
;;;	 (equal lec '(2 13))
;;;       )
;;;       (redraw)
;;;       (setq sigue nil)
;;;      )
;;;    )
;;;  )
(setvar "modemacro"
	     
		
		 "HORARIO"
	      
       )					;fin de lectura de sentido del arco

  (if aho
    (setq ang2 (+ ang1 ang)
	  ang0 ang1
    )
    (setq ang2 ang1
	  ang1 (- ang2 ang)
	  ang0 ang2
    )
  )
					;trazar
  (setq	rint (- radio (* diam 0.5))
	rext (+ rint diam)
  )


  (gc:arc radio "ACAD_ISO04W100" 6)




  (gc:arc rext "BYLAYER" 256)

;;;
;;;  	(cons 10 centro)
;;;	(cons 62 col)
;;;	'(8 . "0")
;;;	(cons 6 lty)
;;;	(cons 40 rad)
;;;	(cons 50 ang1)
;;;	(cons 51 ang2)

  (setq ptex1 (polar centro ang1 rext))
  (setq ptex2 (polar centro ang2 rext))
  (setq ptex3 (polar ptex2 (/ (+ ang1 ang2) 2) (- 0 (* 4 diam))))



  (gc:arc rint "BYLAYER" 256)


  (command "_LAYER" "_S" "Cotas" "")

  (gc:acra centro radio angrr2 "F.N.")
  (gc:acra centro rint angrr1 "Int.")
  (gc:acra centro rext angrr3 "Ext.")

;;;  (command "_dimaligned" ptex1 ptex2 ptex3 "")

  (while
    (if	aho
      (< ang1 ang2)
      (> ang2 ang1)
    )
     (if aho
       (setq ang0 ang1
	     ang1 (+ ang1 incr)
       )
       (setq ang0 ang2
	     ang2 (- ang2 incr)
       )
     )
     (gc:lin (polar centro ang0 rint) (polar centro ang0 rext))


     (setq contador (+ 1 contador))


     (if (= contador 1)
       (progn (setq pt1	    (polar centro ang0 rint)
		    anguant ang0
		    ptini   pt1
	      )

	      (setq pt2	 (polar centro ang0 rint)

		    pti2 (polar centro (/ (+ anguant ang0) 2) rint)
		    pm1	 (jm:pm pt1 pt2)
	      )






       )
     )

     (if (>= contador 2)
       (progn (setq pt2	 (polar centro ang0 rint)

		    pti2 (polar centro (/ (+ anguant ang0) 2) rint)
		    pm1	 (jm:pm pt1 pt2)
	      )
	      (command "_dimaligned" pt1 pti2 pti2 "")
	      (command "_dimaligned" pt1 pt2 pt2 "")

	      (command "_dimtedit"
		       (entlast)
		       (list
			 (+ (/ (- (car pt2) (car pt1)) 1.7) (car pt1))
			 (+ (/ (- (cadr pt2) (cadr pt1)) 1.7) (cadr pt1))
		       )
		       ""
	      )

	      (command "_dimaligned" pti2 pm1 pti2 "")
	      (setq anguant ang0
		    pt1	pt2
	      )

       )
     )


     (gc:aco (if aho
	       ang0
	       (max ang2 ang1)
	     )
	     (if aho

	       (min ang1 ang2)
	       ang0
	     )
	     1
	     "f.n. <>"
	     radio
     )

;;;     (setq ultimofn (entlast))




     (gc:aco (if aho
	       ang0
	       (max ang2 ang1)
	     )
	     (if aho
	       (min ang1 ang2)
	       ang0
	     )
	     2
	     "Ext. <>"
	     rext
     )

;;;     (setq ultimoext (entlast))

  )
  (command "_dimaligned" ptex1 ptex2 ptex3 "")

  (gc:lin (polar centro
		 (if aho
		   ang2
		   ang1
		 )
		 rint
	  )
	  (polar centro
		 (if aho
		   ang2
		   ang1
		 )
		 rext
	  )
  )
  (if (>= contador 2)
    (progn
      (gc:aco
	(if aho
	  ang2
	  ang1
	)
	(if aho
	  (- ang2 ang)
	  (+ ang1 ang)
	)

	3
	"f.n. TOTAL <>"
	radio
      )

      (gc:aco
	(if aho
	  ang2
	  ang1
	)
	(if aho
	  (- ang2 ang)
	  (+ ang1 ang)
	)

	4
	"Ext. TOTAL <>"
	rext
      )
    )
  )

  (setq	pt0   (polar centro
		     (if aho
		       ang2
		       ang1
		     )
		     rint
	      )
	angu0 (if aho
		ang2
		ang1
	      )

  )



  (if (>= contador 2)
    (command "_dimaligned" pt0 ptini ptini "")
  )



  (setq

    pti0 (polar centro (/ (+ anguant angu0) 2) rint)
    pm0	 (jm:pm pt2 pt0)
  )
  (command "_dimaligned" pt2 pti0 pti0 "")
  (command "_dimaligned" pt2 pt0 pt0 "")
  (command "_dimtedit"
	   (entlast)
	   (list
	     (+ (/ (- (car pt0) (car pt2)) 1.4) (car pt2))
	     (+ (/ (- (cadr pt0) (cadr pt2)) 1.4) (cadr pt2))
	   )
	   ""
  )






  (command "_dimaligned" pti0 pm0 pti0 "")




  (setvar "modemacro" "")
  (princ)

  (command "_LAYER" "_S" "0" "")

  (setvar "OSMODE" ref)
)

(alert "Comando cargado: \"tuboarqueado\"")
